//Modifies TCP stack settings for Windows XP to fool passive (TCP/IP) OS detection.
//Tested on Windows XP, but should work on all Windows versions with the proper changes to the registry keys.
//(08/03/06)
//Craig Heffner

#include <windows.h>
#include <stdio.h>

int setvalue(char string[512]);
int control(char string[512]);
int setmtu(DWORD value_mtu);
int usage();
int a,i=0,g=0;
DWORD version;
TCHAR buff[2048];
DWORD bufflen=2048;
DWORD numsubkeys;
DWORD lensubkey;
char str[1024];
HKEY hkey,hkey2,hkey3;
LONG status;
DWORD type=REG_DWORD;
DWORD value_init;
DWORD size=sizeof(DWORD);
DWORD disp=0;
LPDWORD lpdisp=&disp;
char dword_str[512];

int main(int argc,  char  *argv[])
{
        //check usage
        if(argc != 2){usage(); return(0);}
        //check to make sure key exists
        status=RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters",0L,KEY_ALL_ACCESS,&hkey);
        if(status==ERROR_SUCCESS){
            a=control(argv[1]);
        } else {
            printf("Unable to write to registry. Please ensure that you are running Windows XP.");
            return(0);
        }
        
        if(a==1){
            printf("\nTCP stack settings complete. You must reboot in order to these changes to take effect.\nPlease visit http://lcamtuf.coredump.cx/p0f-help/ to ensure that the settings have been successful.\n");
        } else {
            usage();
        }
        return(0);
}        

int control(char string[512])
{
        int i=0,ttl,stamp,pmtu,urg,window,sack;
        char dword_ttl[]="DefaultTTL";
        char dword_1323[]="Tcp1323Opts";
        char dword_pmtu[]="EnablePMTUDiscovery";
        char dword_1122[]="TcpUseRFC1122UrgentPointer";
        char dword_window[]="TcpWindowSize";
        char dword_sack[]="SackOpts";
        
        if(strcmp(string,"sega")==0){
            ttl=128;
            stamp=0;
            pmtu=0;
            urg=0;
            window=4096;
            sack=0;
            setmtu(1500);
        } else if(strcmp(string,"hpux")==0){
            ttl=60;
            stamp=0;
            pmtu=0;
            urg=0;
            window=32768;
            sack=0;   
            //setmtu(1500);    
        } else if(strcmp(string,"playstation")==0){
            ttl=64;
            stamp=0;
            pmtu=1;
            urg=0;
            window=32120;
            sack=0;
            setmtu(1500);
        } else if(strcmp(string,"linux")==0){
            ttl=64;
            stamp=0;
            pmtu=0;
            urg=0;
            window=16384;
            sack=0;
            //setmtu(1500);
        } else if(strcmp(string,"novell")==0){
            ttl=598;
            stamp=0;
            pmtu=1;
            urg=0;
            window=16384;
            sack=0;
            setmtu(1500);
        } else if(strcmp(string,"beos")==0){
            ttl=255;
            stamp=1;
            pmtu=0;
            urg=0;
            window=1024;
            sack=0;
            setmtu(1280);//MTU must also be set to 1280
        } else if(strcmp(string,"tru64")==0){
            ttl=60;
            stamp=1;
            pmtu=0;
            urg=0;
            window=61440;
            sack=0;
            //setmtu(1500);
        } else if(strcmp(string,"freebsd")==0){
            ttl=64;
            stamp=0;
            pmtu=1;
            urg=0;
            window=16384;
            sack=0;
            //setmtu(1500);
        } else if(strcmp(string,"wince")==0){
            ttl=255;
            stamp=0;
            pmtu=1;
            urg=0;
            window=32768;
            sack=0;
            setmtu(1500);
        } else if(strcmp(string,"winxpsp1")==0){
            ttl=128;
            stamp=1;
            pmtu=1;
            urg=0;
            window=32767;
            sack=0;
            setmtu(1500);
        } else if(strcmp(string,"win98")==0){
            ttl=255;
            stamp=0;
            pmtu=1;
            urg=0;
            window=65535;
            sack=0;
            //setmtu(1500);
        } else if(strcmp(string,"irix")==0){
            ttl=60;
            stamp=0;
            pmtu=0;
            urg=0;
            window=49152;
            sack=0;
            //setmtu(1500);
        } else if(strcmp(string,"sunos")==0){
            ttl=64;
            stamp=0;
            pmtu=0;
            urg=0;
            window=4096;
            sack=0;
            setmtu(1500);
        } else if(strcmp(string,"checkpoint")==0){
            ttl=64;
            stamp=0;
            pmtu=1;
            urg=0;
            window=17520;
            sack=0;
            setmtu(1500);
        } else if(strcmp(string,"os400")==0){
            ttl=64;
            stamp=0;
            pmtu=0;
            urg=0;
            window=8192;
            sack=0;
            setmtu(576);//MTU must also be set to 576
        } else if(strcmp(string,"palmos3.5")==0){
            ttl=255;
            stamp=0;
            pmtu=0;
            urg=0;
            window=2948;
            sack=0;
            setmtu(576);//MTU must also be set to 576
        } else if(strcmp(string,"palmos5.2")==0){
            ttl=255;
            stamp=0;
            pmtu=0;
            urg=0;
            window=16384;
            sack=0;
            setmtu(1438);//MTU must be 1438
        } else if(strcmp(string,"dos")==0){
            ttl=255;
            stamp=0;
            pmtu=0;
            urg=0;
            window=2048;
            sack=0;
            setmtu(576);//MTU must be 576
        } else if(strcmp(string,"winnt")==0){
            ttl=128;
            stamp=0;
            pmtu=1;
            urg=0;
            window=45074;
            sack=0;
            setmtu(1454);//MTU must be 1454
        } else if(strcmp(string,"win2000")==0){
            ttl=128;
            stamp=1;
            pmtu=1;
            urg=0;
            window=40320;
            sack=0;
            setmtu(1500);
        } else {
            return(0);
        }
              
        while(i<6){
        if(i==0){strcpy(dword_str,dword_ttl);value_init=ttl;
        } else if(i==1){strcpy(dword_str,dword_1323);value_init=stamp; 
        } else if(i==2){strcpy(dword_str,dword_pmtu);value_init=pmtu;   
        } else if(i==3){strcpy(dword_str,dword_1122);value_init=urg;        
        } else if(i==4){strcpy(dword_str,dword_window);value_init=window;
        } else if(i==5){strcpy(dword_str,dword_sack);value_init=sack;}

        setvalue(dword_str);
        i++;     
        }
        return(1);     
}
    
int setmtu(DWORD value_mtu){
    if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces",0L,KEY_ALL_ACCESS,&hkey3)==ERROR_SUCCESS){
    RegQueryInfoKey(hkey3,NULL,NULL,NULL,&numsubkeys,&lensubkey,NULL,NULL,NULL,NULL,NULL,NULL);

    while(i<numsubkeys){
    RegEnumKeyEx(hkey3,i,buff,&bufflen,NULL,NULL,NULL,NULL);
    strcpy(str,"SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters\\Interfaces\\");
    if(i==0){
        if(strchr(buff,'}')){
            g=1;
        }
    } else {
        if(g==1 && !strchr(buff,'}')){
            strcat(buff,"}");
        }
    } 
    strcat(str,buff);  
    if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,str,0L,KEY_ALL_ACCESS,&hkey2)==ERROR_SUCCESS){             
    //printf("There are %d subkeys. The first key is: %s\n",numsubkeys,str);
    RegSetValueEx(hkey2,"MTU",0L,REG_DWORD,(CONST BYTE *)&value_mtu,size);
    i++;
    }}
    } else {
        printf("ERROR - Couldn't open specified key.\n");
    }               
    
    return(0);    
}
    
int setvalue(char string[512])
{
    RegSetValueEx(hkey,string,0L,REG_DWORD,(CONST BYTE *)&value_init,size);
    return(0);
}
 
int usage()
{
    printf("\nImproper option supplied. Valid options are:\n\nsega\nhpux\nplaystation\nlinux\novell\ntru64\nfreebsd\nwince\nwinxpsp1\nwin98\nirix\nsunos\ncheckpoint\nwin2000\nbeos\t\t(MTU=1280)\nos400\t\t(MTU=576)\npalmos3.5\t(MTU=576)\npalmos5.2\t(MTU=1438)\ndos\t\t(MTU=576)\nwinnt\t\t(MTU=1454)\n\nPlease see the README file for more detailed information.\n\n"); 
    return(0);
}
